# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from django.db import migrations, models


class Migration(migrations.Migration):

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='Excerpt',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('xml_id', models.IntegerField()),
            ],
        ),
        migrations.CreateModel(
            name='Segment',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('seg_entry_id', models.IntegerField()),
                ('xml_id', models.IntegerField(db_index=True)),
                ('choice_id', models.IntegerField(null=True, blank=True)),
                ('paren_id', models.IntegerField(null=True, blank=True)),
                ('is_rejected', models.IntegerField(default=0, choices=[(0, 'Segment nie ma ustalonego statusu.'), (1, 'Segment zatwierdzony (jako sk\u0142adnik "choice").'), (-1, 'Segment usuni\u0119ty (jako sk\u0142adnik "choice").')])),
                ('sent_end', models.BooleanField(default=False)),
                ('nps', models.BooleanField(default=False)),
                ('seg_type', models.CharField(max_length=20, blank=True)),
                ('orth', models.CharField(db_index=True, max_length=128, blank=True)),
                ('translit', models.CharField(max_length=128, blank=True)),
                ('interps', models.TextField()),
                ('base', models.CharField(max_length=250, blank=True)),
                ('ctag', models.CharField(max_length=20, blank=True)),
                ('msd', models.CharField(max_length=250, blank=True)),
                ('radio_id', models.CharField(max_length=10, blank=True)),
                ('excerpt', models.ForeignKey(to='annotation.Excerpt')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Text',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('text_name', models.CharField(max_length=200, db_index=True)),
                ('dirname', models.CharField(max_length=128)),
                ('import_date', models.DateTimeField(auto_now=True, verbose_name=b'data importu')),
            ],
        ),
        migrations.AddField(
            model_name='excerpt',
            name='text',
            field=models.ForeignKey(to='annotation.Text'),
        ),
    ]
