from django.core.serializers.json import DjangoJSONEncoder
from django.db.models.query import QuerySet
import json
from django.utils.safestring import mark_safe
from django import template

register = template.Library()

@register.filter
def jsonify_a(object):
    if isinstance(object, QuerySet):
        return mark_safe(json.dumps(list(object.values()), cls=DjangoJSONEncoder))
    return mark_safe(json.dumps(object))
