# -*- coding: utf-8 -*-
"""anotatornia2 URL Configuration

The `urlpatterns` list routes URLs to views. For more information please see:
    https://docs.djangoproject.com/en/1.8/topics/http/urls/
Examples:
Function views
    1. Add an import:  from my_app import views
    2. Add a URL to urlpatterns:  url(r'^$', views.home, name='home')
Class-based views
    1. Add an import:  from other_app.views import Home
    2. Add a URL to urlpatterns:  url(r'^$', Home.as_view(), name='home')
Including another URLconf
    1. Add an import:  from blog import urls as blog_urls
    2. Add a URL to urlpatterns:  url(r'^blog/', include(blog_urls))
"""
from django.conf.urls import include, url
from django.contrib import admin
from django.contrib.auth.views import login, logout, password_change, password_change_done, password_reset, password_reset_done, password_reset_confirm, password_reset_complete

urlpatterns = [
    url(r'^', include('annotation.urls', namespace="annotation")),
    url(r'^admin/', include(admin.site.urls)),
    url(r'^accounts/login/$',  login, name='login'),
    url(r'^accounts/logout/$', logout, {'next_page': '/', 'extra_context':{'message':u'Pomyślnie wylogowano.'}}, name='logout'),
    url(r'^accounts/password_change/$', password_change, {'template_name': 'registration/password_change_form_new.html'}, name='password_change'),
    url(r'^accounts/password_change/done/$', password_change_done, {'template_name': 'registration/password_change_done_new.html'}, name='password_change_done'),
    url(r'^accounts/password_reset/$', password_reset, {'template_name': 'registration/password_reset_form_new.html', 'html_email_template_name': 'registration/password_reset_email_new.html', 'subject_template_name': 'registration/password_reset_subject_new.txt'}, name='password_reset'),
    url(r'^accounts/password_reset/done/$', password_reset_done, {'template_name': 'registration/password_reset_done_new.html'}, name='password_reset_done'),
    url(r'^accounts/reset/(?P<uidb64>[0-9A-Za-z_\-]+)/(?P<token>[0-9A-Za-z]{1,13}-[0-9A-Za-z]{1,20})/$', password_reset_confirm, {'template_name': 'registration/password_reset_confirm_new.html'}, name='password_reset_confirm'),
    url(r'^accounts/reset/done/$', password_reset_complete, {'template_name': 'registration/password_reset_complete_new.html'}, name='password_reset_complete'),
]
