/* global variable: viewModel */

var annotation_viewModel = function(){
    var self = this;
    
    self.notes = ko.observable(exc_notes);
    self.show_translit = ko.observable(true); //czy wyświetlać tekst transliterowany (true), czy transkrybowany
    self.current_seg = ko.observable(); //identyfikator bieżącego segmentu w knock_segs
    self.firstSentCut = ko.observable(false);
    self.lastSentCut = ko.observable(false);
    self.showFirstSentCut = ko.observable(false);
    self.showLastSentCut = ko.observable(false);
    self.new_translit = ko.observable();
    self.new_orth = ko.observable();
    self.knock_segs = ko.observableArray();
    self.lastRefId = -1; 
    
    self.endWork = function() {
      self.sendAjaxRequest('/' + exc_id + '/excerpt_post/', {action: 'endWork', exc_id: exc_id}, function(resp) {odp(resp, false);}, true);
    };
    
    self.endWorkRef = function() {
      self.sendAjaxRequest('/' + exc_id + '/excerpt_post/', {action: 'endWorkRef', exc_id: exc_id}, function(resp) {odp(resp, true);}, true);
    };

    var odp = function(resp, ref) {
      //alert(resp.resp_message); 
      if (resp.resp_code == 'OK') { $("#mod_title").html('') };
      $("#mod_text").html('<p>' + resp.resp_message + '</p>')
      $("#mod_alert").modal('show');
      $('#mod_alert').on('hidden.bs.modal', function () {
        if (resp.resp_code == 'OK') {
          if (ref) {
            window.location.replace("/superlist/");
          } else {
            window.location.replace("/");
          }};
      });
    };
      
    self.firstCut = function(){
      if (self.firstSentCut()){
        return {style: "btn btn-primary btn-xs", title: "przywróć pierwsze zdanie"}
      } else {
        return {style: "btn btn-default btn-xs", title: "usuń pierwsze zdanie"}
      }
    };

    self.lastCut = function(){
      if (self.lastSentCut()){
        return {style: "btn btn-primary btn-xs", title: "przywróć ostatnie zdanie"}
      } else {
        return {style: "btn btn-default btn-xs", title: "usuń ostatnie zdanie"}
      }
    };

    self.sentEndStyle = function(seg){
      if (seg.fields.sent_end()){
        return {style: "btn btn-primary btn-xs", title: "usuń koniec zdania"}
      } else {
        return {style: "btn btn-default btn-xs", title: "ustaw koniec zdania"}
      }
    };
    
    self.choiceStyle = function(seg){
      if (seg.fields.is_rejected() != 0){
        return {style: "btn btn-primary btn-xs", title: "zmień segmentację"}
      } else {
        return {style: "btn btn-default btn-xs", title: "wybierz segmentację"}
      }
    };

    self.choiceRefStyle = function(seg){
      if (seg.fields.ref_rejected() != 0){
        return {style: "btn btn-primary btn-xs", title: "zmień wybór superanotatora"}
      } else {
        return {style: "btn btn-default btn-xs", title: "wybór superanotatora"}
      }
    };
    self.interpStyle = function(seg){
      if (!seg.interpsView()){
        return {style: "btn btn-primary btn-xs", title: "rozwiń interpretacje"}
      } else {
        return {style: "btn btn-default btn-xs", title: "zwiń interpretacje"}
      }
    };


    var segmentMapping = {
      key: function(item) {
          return ko.utils.unwrapObservable(item.pk);
      },
      create: function(options) {
          return createSegment(options.data);
      }
    };

    var createSegment = function(segment) {
        var result = ko.mapping.fromJS(segment);
        result.isCurrent = ko.observable(false); // czy segment jest bieżącym segmentem
        result.interpsView = ko.observable(true); // czy ma być widoczna lista interpretacji
        result.manualInterpView = ko.observable(false); //czy jest widoczny formularz dodawania własnej interpretacji
        result.manualBase = ko.observable();
        result.manualCtag = ko.observable();
        result.manualMsd = ko.observable();
        result.editTranskrView = ko.observable(false); //czy jest widoczne pole zmiany transkrypcji
        result.manualTranskr = ko.observable(segment.fields.orth);
        result.hidden = ko.computed(function() {
          return (result.fields.is_rejected() < 0) || (result.fields.is_hidden());
        });
        if (result.fields.interps()) {
          interps = JSON.parse(segment.fields.interps);
        } else {
          interps = [];
        };
        result.interps = ko.mapping.fromJS(interps); //pole tekstowe z zapisem JSON trzeba zanalizować...
        delete result.fields.interps; // ... a po zapisaniu w nowym polu usunąć oryginalne
        //console.log(result);
        return result;
    };

    self.sendAjaxRequest = function(path, data, successFunction, asynchr){  //na 'data' powinien być obiekt koniecznie z polem 'action', np.: {action: , seg_id: , sent_end: }
      $.ajax({
        beforeSend: function(xhr, settings) {
          xhr.setRequestHeader("X-CSRFToken", csrf);
        },
        async: asynchr,
        success: successFunction,
//        error: function() {
//          alert('Błąd żądania AJAX');},
        error: function(xhr, status, error) {
          alert('Błąd żądania AJAX: ' + xhr.responseText);
        },
        data : JSON.stringify(data),
        url : path,
        type : 'POST',
        dataType : 'json',
        contentType: 'application/json; charset=UTF-8'
      });
    };

    self.saveNotes = function(){
      self.sendAjaxRequest('/' + exc_id + '/excerpt_post/', {action: 'saveNotes', exc_id: exc_id, notes: self.notes()}, function(resp) {}, true);
      exc_notes = self.notes();
    }

    self.resetNotes = function(){
      self.notes(exc_notes);
    }


    self.textChange = function(){
      var elem_id = "";
      self.show_translit(!self.show_translit());
      //console.log(self.show_translit());
      if (self.show_translit()){
        elem_id = "translit";
      } else {
        elem_id = "orth"
      };
      scroll(elem_id + self.current_seg());
    }
    
    //Zwraca index kolejnego segmentu:
    //- dla anotatora: index + 1
    //- dla superantotatora: kolejny, który nie został odrzucony w superanotacji
    //Jeśli nie ma takiego segmentu, funkcja zwraca -1 
    self.getNext = function(index) {
      var i = index + 1;
      if (mode == 'referee') {
        while (i < self.knock_segs().length) {
          if (self.knock_segs()[i].fields.ref_rejected() == -1) {
            i++;
          } else {
            break;
          };
        };
      };
      if (i >= self.knock_segs().length) {
        return -1;
      } else {
        return i;
      };
    };

    //Zwraca index poprzedniego segmentu:
    //- dla anotatora: index - 1
    //- dla superantotatora: poprzedni, który nie został odrzucony w superanotacji
    //Jeśli nie ma takiego segmentu, funkcja zwraca -1 
    self.getPrev = function(index) {
      var i = index - 1;
      if (mode == 'referee') {
        while (i >= 0) {
          if (self.knock_segs()[i].fields.ref_rejected() == -1) {
            i--;
          } else {
            break;
          };
        };
      };
      if (i < 0) {
        return -1;
      } else {
        return i;
      };
    };
    
    //przełącza wartość logiczną sent_end między true i false
    self.toggleSentEnd = function(index, seg, event){
      var next_index = self.getNext(index);
      if (seg.fields.sent_end()) {
        if (next_index == -1) {
          alert('Nie można usunąć końca zdania na ostatnim segmencie.');
          return;
        } else if (self.knock_segs()[next_index].fields.is_hidden()) {
          alert('Nie można usunąć końca zdania na ostatnim segmencie przed ukrytym fragmentem.');
          return;
        };
      } else if ((seg.fields.xml_id() == self.knock_segs()[next_index].fields.xml_id()) && (seg.fields.choice_id() == self.knock_segs()[next_index].fields.choice_id())) {
        alert('Nie można ustawić końca zdania na nieostatnim segmencie choice.');
        return;
      };
      var new_value = !seg.fields.sent_end();
      var idArr = [seg.pk()];
      if (seg.fields.choice_id()) { // wybrano ostatni składnik choice - trzeba ustawić/usunąć oznaczenie ze wszystkich choice
        seg.fields.sent_end(new_value);
        i = index - 1;
        ch_id = seg.fields.choice_id();
        while ((i>=0) && (self.knock_segs()[i].fields.xml_id() == seg.fields.xml_id()) && (self.knock_segs()[i].fields.user() == seg.fields.user())) {
          if (self.knock_segs()[i].fields.choice_id() != ch_id) {
            idArr.push(self.knock_segs()[i].pk());
            self.knock_segs()[i].fields.sent_end(new_value);
            ch_id = self.knock_segs()[i].fields.choice_id();
          };
          i--;
        };
        i = index + 1;
        if (i < self.knock_segs().length) {
          ch_id = self.knock_segs()[i].fields.choice_id();
          while ((i < self.knock_segs().length) && (self.knock_segs()[i].fields.xml_id() == seg.fields.xml_id()) && (self.knock_segs()[i].fields.user() == seg.fields.user())) {
            if (self.knock_segs()[i].fields.choice_id() != ch_id) {
              idArr.push(self.knock_segs()[i-1].pk());
              self.knock_segs()[i-1].fields.sent_end(new_value);
              ch_id = self.knock_segs()[i].fields.choice_id();
            };
            i++;
          };
          idArr.push(self.knock_segs()[i-1].pk());
          self.knock_segs()[i-1].fields.sent_end(new_value);            
        };
      } else {
        seg.fields.sent_end(new_value);
      };
      self.sendAjaxRequest('/' + exc_id + '/excerpt_post/', {action: 'setSentEnd', seg_id: idArr, sent_end: new_value}, function(resp) {}, true);
      self.select(index, seg, event);
    };


    //wybór wariantu w superanotacji
    self.toggleChoiceRef = function(index, seg, event){
      var requestArr = []; //lista par (seg_id, ref_rejected) do zmiany w bazie danych
      var refid = seg.fields.ref_id();
      var rejected = seg.fields.ref_rejected();
      var userid = seg.fields.user();
      var i = index;
      var iStart = index;
      var iEnd = index;
      var testSeg;

      var refidArr = []; //lista indeksów segmentów dla danego refid
      refidArr.push(index);
      i = index - 1;
      while (i >= 0) {
        if (self.knock_segs()[i].fields.ref_id() == refid) {
          if (self.knock_segs()[i].fields.user() == userid) { iStart = i; };
          refidArr.unshift(i);
          i--;
        } else {
          break;
        };
      };
      i = index + 1;
      while (i < self.knock_segs().length) {
        if (self.knock_segs()[i].fields.ref_id() == refid) {
          if (self.knock_segs()[i].fields.user() == userid) { iEnd = i; };
          refidArr.push(i);
          i++;
        } else {
          break;
        };
      };
      
      if (!rejected) {
        //Jeśli ustalany fragment miałby się rozpocząć od ukrytego segmentu, 
        //to sprawdź czy poprzedni jest ustalony i kończy zdanie.
        if (self.knock_segs()[iStart].fields.is_hidden()) {
          i = self.getPrev(refidArr[0]);
          if (i != -1) {
            testSeg = self.knock_segs()[i];
            if (testSeg.fields.ref_rejected() == 0) {
              alert('Nie można wybrać wersji, która rozpoczyna się ukrytym segmentem, a poprzedzający go segment nie ma ustalonej wersji.');
              return;
            } else {
              if (!testSeg.fields.sent_end()) {
              alert('Nie można wybrać wersji, która rozpoczyna się ukrytym segmentem, a poprzedzający go segment nie ma ustawionego końca zdania.');
              return;
              };
            };
          };
        };
        //Jeśli pierwszy segment za obecnie ustalanym ciągiem jest ustalony i ukryty,
        //to sprawdź, czy ostatni segment wybieranego fragmentu ma oznaczenie końca zdania.
        i = self.getNext(refidArr[refidArr.length - 1]);          
        if (i != -1) {
          testSeg = self.knock_segs()[i];
          if ((testSeg.fields.ref_rejected() == 1) && testSeg.fields.is_hidden() && !self.knock_segs()[iEnd].fields.sent_end()) {
            alert('Nie można wybrać wersji, której ostatni segment nie kończy zdania, a kolejny jest ukryty.');
            return;
          };
        };
      };

      // uaktualnij wartości odpowiadające za pokazywanie przycięcia zdania
      if (refid == 1) {
        if (rejected) {
          self.showFirstSentCut(false); 
        } else {
          if (!userid) {
            self.showFirstSentCut(true);
            if (self.knock_segs()[iStart].fields.is_hidden()) {
              self.firstSentCut(true);
            } else {
              self.firstSentCut(false);
            };
          };
        };
      } else {
        if (refid == self.lastRefId) {
          if (rejected) {
            self.showLastSentCut(false); 
          } else {
            if (!userid) {
              self.showLastSentCut(true);
              if (self.knock_segs()[iEnd].fields.is_hidden()) {
                self.lastSentCut(true);
              } else {
                self.lastSentCut(false);
              };
            };
          };
        };
      };
      
      if (rejected) {  //kliknięty element był wybrany - nadaj wszystkim elementom refidArr ref_rejected == 0
        for (j=0; j < refidArr.length; j++) {
            self.knock_segs()[refidArr[j]].fields.ref_rejected(0);  //Reject_status = UNSET
            requestArr.push({seg_id: self.knock_segs()[refidArr[j]].pk(), reject: 0});
        };
      } else {  //kliknięty element nie był jeszcze wybrany - nadaj mu 1, a tym od pozostałych użytkowników -1
        for (j=0; j < refidArr.length; j++) {
          if ((refidArr[j] < iStart) || (refidArr[j] > iEnd)) {
            self.knock_segs()[refidArr[j]].fields.ref_rejected(-1);  //Reject_status = YES
            requestArr.push({seg_id: self.knock_segs()[refidArr[j]].pk(), reject: -1});
          } else {
            self.knock_segs()[refidArr[j]].fields.ref_rejected(1);  //Reject_status = NO
            requestArr.push({seg_id: self.knock_segs()[refidArr[j]].pk(), reject: 1});
          };
        };
      };
      self.sendAjaxRequest('/' + exc_id + '/excerpt_post/', {action: 'setRejectedRef', data: requestArr}, function(resp) {}, true);
      self.select(index, seg, event);
    };


    //wybór podziału na segmenty
    self.toggleChoice = function(index, seg, event){
      var requestArr = []; //lista par (seg_id, is_rejected) do zmiany w bazie danych
      var choiceArr = []; //lista indeksów segmentów w danym 'choice'
      //wstaw na choiceArr kliknięty element a następnie wszystkie przed i za klikniętym, które należą do tego samego 'choice'
      choiceArr.push(index);
      i = index - 1;
      while (i >= 0) {
        if ((self.knock_segs()[i].fields.xml_id() == seg.fields.xml_id()) && (self.knock_segs()[i].fields.user() == seg.fields.user())) {
          choiceArr.unshift(i);
          i--;
        } else {
          break;
        };
      };
      i = index + 1;
      while (i < self.knock_segs().length) {
        if ((self.knock_segs()[i].fields.xml_id() == seg.fields.xml_id()) && (self.knock_segs()[i].fields.user() == seg.fields.user())) {
          choiceArr.push(i);
          i++;
        } else {
          break;
        };
      };
      
      if (seg.fields.is_rejected()) { //kliknięty element był wybrany - przywróć wybór spośród wszystkich składników 'choice'
        for (j=0; j < choiceArr.length; j++) {
          self.knock_segs()[choiceArr[j]].fields.is_rejected(0);  //Reject_status: UNSET
          requestArr.push({seg_id: self.knock_segs()[choiceArr[j]].pk(), reject: 0});
        };
      } else { //kliknięty element z nieustalonego choice - wybierz daną segmentację
        var choice_nr = seg.fields.choice_id();
        for (j=0; j < choiceArr.length; j++) {
          if (self.knock_segs()[choiceArr[j]].fields.choice_id() != choice_nr) {
            self.knock_segs()[choiceArr[j]].fields.is_rejected(-1); //Reject_status: YES
            requestArr.push({seg_id: self.knock_segs()[choiceArr[j]].pk(), reject: -1});
          } else {
            self.knock_segs()[choiceArr[j]].fields.is_rejected(1); //Reject_status: NO
            requestArr.push({seg_id: self.knock_segs()[choiceArr[j]].pk(), reject: 1});
          };
        };
      };
      self.sendAjaxRequest('/' + exc_id + '/excerpt_post/', {action: 'setRejected', data: requestArr}, function(resp) {}, true);
      self.select(index, seg, event);
    };

    //przełączanie widoku interpretacji
    self.toggleInterpsView = function(index, data, event){
      if ((mode == 'annotator') || (!data.fields.user())) { //przełączanie działa w widoku anotatora lub superanotatora (ale tylko w jego segmentach)
        if (data.fields.base()) { //przełączać widok można tylko, jeśli jest już ustawiona jakaś interpretacja
          data.interpsView(!data.interpsView());
        }
        self.select(index, data, event);
      };
    };

    //włączenie widoku zmiany trankskrypcji
    self.toggleTranskrView = function(index, data, event){
      data.editTranskrView(!data.editTranskrView());
      data.manualTranskr(data.fields.orth());
      self.select(index, data, event);
    };

    //przełącza ukrywanie pierwszego/ostatniego zdania
    self.toggleSentCut = function(which, data, event) {
      var segArr = []; //lista identyfikatorów segmentów do zmiany
      if (which == 'first') {
        j = 0;
        var cutVal = self.firstSentCut();
        while (j < self.knock_segs().length) {
          var seg = self.knock_segs()[j];
          if (!cutVal && (!seg.fields.user() || (mode == 'annotator') && seg.fields.is_hidden())) { return; }; //może wystąpić na pierwszym segmencie tylko, jeśli w próbce jest tylko jedno zdanie już oznaczone jako ukryte
          seg.fields.is_hidden(!cutVal);
          segArr.push(seg.pk());
          if (seg.fields.sent_end()) { break; };
          j++;
        };
        // czy trzeba przenieść oznaczenie bieżącego segmentu?
        if (cutVal) { //jest ukryte - odkrywamy
          if ((self.current_seg() > j) && (self.knock_segs()[self.current_seg()].fields.is_hidden())) {
            self.knock_segs()[self.current_seg()].isCurrent(false);
            self.current_seg(j);
            self.knock_segs()[j].isCurrent(true);            
          };
        } else { //jest odkryte - ukrywamy
          if ((j < self.knock_segs().length -1) && (self.current_seg() <= j)) {
            seg_plus = self.knock_segs()[j+1];
            if (!seg_plus.fields.is_hidden()) {
              self.knock_segs()[self.current_seg()].isCurrent(false);
              self.current_seg(j+1);
              seg_plus.isCurrent(true);
            };
          };
        };
        self.firstSentCut(!cutVal);
      } else if (which == 'last') {
        j = self.knock_segs().length - 1;
        var cutVal = self.lastSentCut();
        while (j >= 0) {
          var seg = self.knock_segs()[j];
          if (!cutVal && seg.fields.is_hidden()) { return }; //może wystąpić na ostatnim segmencie tylko, jeśli w próbce jest tylko jedno zdanie już oznaczone jako ukryte
          seg.fields.is_hidden(!cutVal);
          segArr.push(seg.pk());
          if (j > 0 && self.knock_segs()[j-1].fields.sent_end()) { break };
          j--;
        };
        // czy trzeba przenieść oznaczenie bieżącego segmentu?
        if (cutVal) { //jest ukryte - odkrywamy
          if ((self.current_seg() < j) && (self.knock_segs()[self.current_seg()].fields.is_hidden())) {
            self.knock_segs()[self.current_seg()].isCurrent(false);
            self.current_seg(j);
            self.knock_segs()[j].isCurrent(true);            
          };
        } else { //jest odkryte - ukrywamy
          if ((j > 0) && (self.current_seg() >= j)) {
            seg_minus = self.knock_segs()[j-1];
            if (!seg_minus.fields.is_hidden()) {
              self.knock_segs()[self.current_seg()].isCurrent(false);
              self.current_seg(j-1);
              seg_minus.isCurrent(true);
            };
          }
        };
        self.lastSentCut(!cutVal);
      };
      self.sendAjaxRequest('/' + exc_id + '/excerpt_post/', {action: 'sentCut', data: segArr}, function(resp) {}, true);
      scroll('segm' + self.current_seg());
      if (self.show_translit()){
        scroll("translit" + self.current_seg());
      } else {
        scroll("orth" + self.current_seg());
      };
    };


    //przełącza ukrywanie pierwszego/ostatniego zdania w wersji superanotatora
    self.toggleSentCutRef = function(which, data, event) {
      var segArr = []; //lista identyfikatorów na liście knockout
      var requestArr = []; // lista identyfikatorów do zmiany w bazie
      var seg_next;
      if (which == 'first') {
        j = self.getNext(-1); //znajdź pierwszy niewyeliminowany w superanotacji segment
        if (j == -1) {return; }; //właściwie nie ma takiej możliwości, ale...
        var cutVal = self.firstSentCut();
        while (j < self.knock_segs().length) {
          var seg = self.knock_segs()[j];
          if (seg.fields.ref_rejected() == 0) {
            alert('Pierwsze zdanie musi się składać wyłącznie z segmentów z zatwierdzoną w superanotacji wersją.');
            return;
          } else {
            if (seg.fields.user()) {
              alert('Wszystkie segmenty pierwszego zdania muszą mieć zatwierdzoną wersję superanotatora.');
              return;
            } else {
              if (!cutVal && seg.fields.is_hidden()) { return; }; //może wystąpić na pierwszym segmencie tylko, jeśli w próbce jest tylko jedno zdanie już oznaczone jako ukryte
              segArr.push(j);
              if (seg.fields.sent_end()) { break; };
              j = self.getNext(j);
            };
          };
        };
        // czy trzeba przenieść oznaczenie bieżącego segmentu?
        if (cutVal) { //jest ukryte - odkrywamy
          if ((self.current_seg() > j) && (self.knock_segs()[self.current_seg()].fields.is_hidden())) {
            self.knock_segs()[self.current_seg()].isCurrent(false);
            self.current_seg(j);
            self.knock_segs()[j].isCurrent(true);            
          };
        } else { //jest odkryte - ukrywamy
          if (self.current_seg() <= j) {
            j = self.getNext(j);
            if (j != -1) {
              seg_next = self.knock_segs()[j];
              if (!seg_next.fields.is_hidden()) {
                self.knock_segs()[self.current_seg()].isCurrent(false);
                self.current_seg(j);
                seg_next.isCurrent(true);
              };
            };
          };
        };
        self.firstSentCut(!cutVal);
      } else if (which == 'last') {
        j = self.getPrev(self.knock_segs().length); //znajdź ostatni niewyeliminowany w superanotacji segment
        if (j < 0) {return; }  //właściwie nie powinno się zdarzyć, ale...
        var cutVal = self.lastSentCut();
        while (j >= 0) {
          var seg = self.knock_segs()[j];
          if (seg.fields.ref_rejected() == 0) {
            alert('Ostatnie zdanie musi się składać wyłącznie z segmentów z zatwierdzoną w superanotacji wersją. Zatwierdzony musi być również ostatni segment poprzedniego zdania.');
            return;
          } else {
            if (seg.fields.user()) {
              if (seg.fields.sent_end()) {
                break; //ostatni segment zdania poprzedzającego może mieć zatwierdzoną wersję któregoś z anotatorów
              } else {
                alert('Wszystkie segmenty ostatniego zdania muszą mieć zatwierdzoną wersję superanotatora.');
                return;
              };
            } else {
              if ((segArr.length > 0) && seg.fields.sent_end()) { break; };
              if (!cutVal && seg.fields.is_hidden()) { return; }; //może wystąpić na ostatnim segmencie tylko, jeśli w próbce jest tylko jedno zdanie już oznaczone jako ukryte
              segArr.push(j);
              j = self.getPrev(j);
            };
          };
        };

        // czy trzeba przenieść oznaczenie bieżącego segmentu?
        if (cutVal) { //jest ukryte - odkrywamy
          if ((self.current_seg() < j) && (self.knock_segs()[self.current_seg()].fields.is_hidden())) {
            self.knock_segs()[self.current_seg()].isCurrent(false);
            self.current_seg(j);
            self.knock_segs()[j].isCurrent(true);            
          };
        } else { //jest odkryte - ukrywamy
          if ((j >= 0) && (self.current_seg() > j)) {
            seg_next = self.knock_segs()[j];
            if (!seg_next.fields.is_hidden()) {
              self.knock_segs()[self.current_seg()].isCurrent(false);
              self.current_seg(j);
              seg_next.isCurrent(true);
            };
          }
        };
        self.lastSentCut(!cutVal);
      };
      
      for (i = 0; i < segArr.length; i++) { //musiała być dodatkowa tabela, żeby zmiany w interfejsie nie zachodziły w przypadku błędów
        self.knock_segs()[segArr[i]].fields.is_hidden(!cutVal);
        requestArr.push(self.knock_segs()[segArr[i]].pk());
      };

      self.sendAjaxRequest('/' + exc_id + '/excerpt_post/', {action: 'sentCut', data: requestArr}, function(resp) {}, true);
      
      scroll('segm' + self.current_seg());
      if (self.show_translit()){
        scroll("translit" + self.current_seg());
      } else {
        scroll("orth" + self.current_seg());
      };
    };

    //wybór interpretacji
    self.setInterp = function(index, radio_id, interp, msd, event){
      var seg = self.knock_segs()[index];
      seg.fields.base(interp.base());
      seg.fields.ctag(interp.ctag());
      seg.fields.msd(msd.val());
      seg.fields.radio_id(radio_id);
      seg.fields.manual(msd.manual());
      
      seg.interpsView(false);
      
      self.sendAjaxRequest('/' + exc_id + '/excerpt_post/', {action: 'setInterp', seg_id: seg.pk(), base: interp.base(), ctag: interp.ctag(), msd: msd.val(), radio_id: radio_id, manual: msd.manual(), interps: ko.toJSON(seg.interps())}, function(resp) {if (seg.fields.choice_id() && (seg.fields.is_rejected() == 0)) {self.toggleChoice(index, seg, event);} else {self.select(index, seg, event);};}, true);
    };

    //otworzenie wyboru ręcznej interpretacji na podstawie wybranej
    self.addManualInterp = function(index, interp, msd, event){
      var seg = self.knock_segs()[index];
      var aweid = 'awe' + index.toString();
      seg.manualBase(interp.base());
      seg.manualCtag(interp.ctag());
      seg.manualMsd(msd.val());
      
      //$("#ctag" + index).select2().trigger('change');
      if (typeof window[aweid] == "undefined") {
        window[aweid] = new Awesomplete(document.getElementById('msd' + index.toString()), {
          list: tagset[interp.ctag()],
          //filter: Awesomplete.FILTER_STARTSWITH,
          minChars: 0,
          maxItems: 500,
          autoFirst: true,
          sort: function() {}
        });
        document.getElementById('msd' + index.toString()).addEventListener('awesomplete-selectcomplete',function(){
          //alert(this.value);
          $('#msd' + index.toString()).change();
        });  
      } else {
        window[aweid].list = tagset[interp.ctag()];
        window[aweid].evaluate();
      };

      seg.manualInterpView(true);
      
      self.select(index, seg, event);
      
    }


    //ustawienie wybranej ręcznej interpretacji
    self.setManualInterp = function(index, data, event){
      //Przytnij początkowe i końcowe spacje z lematu
      data.manualBase(data.manualBase().replace(/^\s+|\s+$/g,''));
      //Sprowadź do małych liter zapis w msd a następnie wytnij z niego wszystko poza literami, 0, dwukropkiem i kropką
      data.manualMsd(data.manualMsd().toLowerCase().replace(/[^a-z0123:.]/g,''));
      if (validMsd(data.manualCtag(), data.manualMsd())) {
        data.fields.base(data.manualBase());
        data.fields.ctag(data.manualCtag());
        data.fields.msd(data.manualMsd());
        data.fields.manual(true);
        
        var manualInterp = {
          base: ko.observable(data.manualBase()),
          ctag: ko.observable(data.manualCtag()),
          msd: ko.observableArray([{
            val: ko.observable(data.manualMsd()),
            manual: ko.observable(true)}])
        };
        
        if (data.interps()[0].msd()[0].manual()) {
          data.interps.shift();
        };
          
        data.interps.unshift(manualInterp);
        data.fields.radio_id("0.0");
        
        data.interpsView(false);
        data.manualInterpView(false);
        
        self.sendAjaxRequest('/' + exc_id + '/excerpt_post/', {action: 'setInterp', seg_id: data.pk(), base: data.manualBase(), ctag: data.manualCtag(), msd: data.manualMsd(), radio_id: "0.0", manual: true, interps: ko.toJSON(data.interps())}, function(resp) {if (data.fields.choice_id() && (data.fields.is_rejected() == 0)) {self.toggleChoice(index, data, event);} else {self.select(index, data, event);};}, true);
      };
    }

    //zmiana transkrypcji
    self.setManualTranskr = function(index, data, event){
      data.fields.orth(data.manualTranskr());
      data.fields.orth_manual(true);
      data.editTranskrView(false);
      
      self.sendAjaxRequest('/' + exc_id + '/excerpt_post/', {action: 'setTranskr', seg_id: data.pk(), orth: data.manualTranskr()}, function(resp) {}, true);
      self.select(index, data, event);      
    }

    // zaznacza następny nieukryty segment po tym przekazanym w parametrze.
    var selectNextSeg = function(index){
      var i = self.getNext(index);
      if (i == -1) {return;};
      while ((i < self.knock_segs().length) && (self.knock_segs()[i].hidden())) {
        i++;
      };
      if (i != self.knock_segs().length) {
        self.knock_segs()[self.current_seg()].isCurrent(false);
        self.current_seg(i);
        self.knock_segs()[i].isCurrent(true);
        scroll('segm' + i);
      };
    };
    
    self.segDivide = function(){
      var seg = self.knock_segs()[self.current_seg()];
      var translit_list = self.new_translit().split('|');
      var orth_list = self.new_orth().split('|');
      if (translit_list.join('') != seg.fields.translit()) {
        alert('Nie można zmieniać oryginalnego tekstu transliterowanego - wprowadź do niego wyłącznie znaki "|".');
        self.new_translit(seg.fields.translit());
      } else if (translit_list.length != orth_list.length) {
        alert('Liczba segmentów powstałych z podziału tekstu transliterowanego i transkrybowanego musi się zgadzać.');
        self.new_translit(seg.fields.translit());
        self.new_orth(seg.fields.orth());
      } else if (self.new_translit() != seg.fields.translit()) {
        var index = self.current_seg();
        self.knock_segs()[index].isCurrent(false);
        self.sendAjaxRequest('/' + exc_id + '/excerpt_post/', {action: 'segDivide', mode: mode, seg_id: seg.pk(), translit_l: translit_list, orth_l: orth_list}, function(resp) {dj_segments = resp; ko.mapping.fromJS(dj_segments, segmentMapping, self.knock_segs); selectNextSeg(index);}, true);
        $('#seg_divide').modal('hide');
      };
    };

    // zwraca obiekt z danymi na temat choice, w którym zdajduje się segment o danym indeksie
    var getChoice = function(index){
      var seg = self.knock_segs()[index];
      var word = {translitArr: [seg.fields.translit()], orthArr: [seg.fields.orth()], ident: seg.fields.xml_id(), choice: seg.fields.choice_id(), paren: seg.fields.paren_id(), start: index, end: index, user: seg.fields.user(), ref: seg.fields.ref_id()};
      if (word.choice) {
        var i = index-1;
        while ((i>=0) && (self.knock_segs()[i].fields.xml_id() == word.ident) && (self.knock_segs()[i].fields.choice_id() == word.choice) && (self.knock_segs()[i].fields.user() == word.user)) {
          word.translitArr.unshift(self.knock_segs()[i].fields.translit());
          word.orthArr.unshift(self.knock_segs()[i].fields.orth());
          word.start = i;
          i--
        };
        i = index +1;
        while ((i < self.knock_segs().length) && (self.knock_segs()[i].fields.xml_id() == word.ident) && (self.knock_segs()[i].fields.choice_id() == word.choice) && (self.knock_segs()[i].fields.user() == word.user)) {
          word.translitArr.push(self.knock_segs()[i].fields.translit());
          word.orthArr.push(self.knock_segs()[i].fields.orth());
          word.end = i;
          i++
        };
      };
      return word;
    };

    self.prepareConcat = function(index, data, event){
      var ind_next = self.getNext(index);
      if (ind_next == -1) {
        alert('Nie ma kolejnego segmentu do dołączenia.');
        return;
      };

      var seg = self.knock_segs()[index];
      var seg_next = self.knock_segs()[ind_next];

      var translit1, translit2, orth1, orth2 = '';
      var translit_before = '';
      var orth_before = '';
      var translit_after = '';
      var orth_after = '';
      // jeśli łączenie następuje w ramach jednego paren, to obsłuż lokalnie, wpp. trzeba łączyć na poziomie słów a nie segmentów
      if (seg.fields.paren_id() && (seg_next.fields.xml_id() == seg.fields.xml_id()) && (seg_next.fields.choice_id() == seg.fields.choice_id()) && (seg_next.fields.paren_id() == seg.fields.paren_id() + 1)) {
        action = 'choice'; //action, word1 i word2 to zmienne globalne - używane potem w segConcat
        word1 = getChoice(index);
        var add_space = '';
        if (!seg_next.fields.nps()) {
          add_space = ' ';
        };
        translit1 = seg.fields.translit();
        translit2 = seg_next.fields.translit();
        orth1 = seg.fields.orth();
        orth2 = seg_next.fields.orth();
        translit_before = word1.translitArr.slice(0,seg.fields.paren_id()-1).join('|');
        orth_before = word1.orthArr.slice(0,seg.fields.paren_id()-1).join('|');
        translit_after = word1.translitArr.slice(seg.fields.paren_id()+1, word1.translitArr.length).join('|');
        orth_after = word1.orthArr.slice(seg.fields.paren_id()+1, word1.orthArr.length).join('|');
      } else {
        var is_ref = false;
        if (mode == 'referee') { is_ref = true; };
        action = 'words';
        word1 = getChoice(index); //pobierz pierwsze całe słowo
        if (self.knock_segs()[word1.end].fields.sent_end()) {
          alert('Nie można dołączyć segmentu z innego zdania.');
          return;
        };
        i = word1.end +1; 
        // pomiń kolejne warianty pierwszego słowa
        while ((i < self.knock_segs().length) && (self.knock_segs()[i].fields.xml_id() == word1.ident) && (self.knock_segs()[i].fields.user() == word1.user)) {
          i++;
        };
        if (i >= self.knock_segs().length) {
          alert('Nie ma kolejnego segmentu do dołączenia.');
          return;
        };
        if (is_ref && (self.knock_segs()[i].fields.user() != word1.user)) {  //w wersji superanotatora - pomiń ewentualne ukryte wersje innych anotatorów
          i = self.getNext(i);
        };
        if (i == -1) {
          alert('Nie ma kolejnego segmentu do dołączenia.');
          return;
        };
        
        if (is_ref && (self.knock_segs()[i].fields.ref_rejected() == 0)) {
          alert('Aby dokonać połączenia musisz najpierw wybrać własną wersję dołączanego segmentu');
          return;
        };

        if (is_ref && (self.knock_segs()[i].fields.user() != word1.user)) {
          alert('Nie można łączyć z segmentem innego anotatora.');
          return;
        };
      
        // pomiń segmenty z ukrytych wariantów drugiego słowa
        while ((i < self.knock_segs().length) && (self.knock_segs()[i].fields.is_rejected() < 0) && !self.knock_segs()[i].fields.is_hidden()){
          i++;
        };
        if ((i >= self.knock_segs().length) || self.knock_segs()[i].fields.is_hidden()) {
          alert('Nie ma kolejnego nieukrytego segmentu do dołączenia.');
          return;
        };
        word2 = getChoice(i);
        if (self.knock_segs()[word1.end].fields.seg_type() != self.knock_segs()[word2.start].fields.seg_type()) {
          alert('Nie można łączyć segmentów różnych typów: "' + self.knock_segs()[word1.end].fields.seg_type() + '" oraz "' + self.knock_segs()[word2.start].fields.seg_type() + '".');
          return;
        };
        if (self.knock_segs()[word1.end].fields.corresp_elem() != self.knock_segs()[word2.start].fields.corresp_elem()) {
          alert('Nie można łączyć segmentów pochodzących z różnych elementów struktury XML: "' + self.knock_segs()[word1.end].fields.corresp_elem() + '" oraz "' + self.knock_segs()[word2.start].fields.corresp_elem() + '".');
          return;
        };
        if ((self.knock_segs()[word1.end].interps().length == 0) || (self.knock_segs()[word2.start].interps().length == 0)) {
          alert('Nie można łączyć segmentów, z których co najmniej jeden nie posiada interpretacji.');
          return;
        };
      
        var add_space = '';
        if (!self.knock_segs()[word2.start].fields.nps()) {
          add_space = ' ';
        };
        translit1 = word1.translitArr[word1.translitArr.length - 1];
        translit2 = word2.translitArr[0];
        orth1 = word1.orthArr[word1.orthArr.length - 1];
        orth2 = word2.orthArr[0];
        translit_before = word1.translitArr.slice(0,-1).join('|');
        orth_before = word1.orthArr.slice(0,-1).join('|');
        translit_after = word2.translitArr.slice(1, word2.translitArr.length).join('|');
        orth_after = word2.orthArr.slice(1, word2.orthArr.length).join('|');
      };
      if (translit_before) { translit_before += '|' };
      if (orth_before) { orth_before += '|' };        
      if (translit_after) { translit_after = '|' + translit_after};
      if (orth_after) { orth_after = '|' + orth_after};        
      self.new_translit(translit_before + '<span class="bg-danger"><strong>' + translit1 + add_space + translit2 + '</strong></span>' + translit_after);
      self.new_orth(orth_before + '<span class="bg-danger"><strong>' + orth1 + add_space + orth2 + '</strong></span>' + orth_after);
      $('#seg_concat').modal('show');
    };
    
    self.segConcat = function(){
      //alert(action);
      var index = self.current_seg();
      self.knock_segs()[index].isCurrent(false);
      if (action == 'words') {
        self.sendAjaxRequest('/' + exc_id + '/excerpt_post/', {action: 'segConcat', mode: mode, exc_id: exc_id, user: word1.user, word1_id: word1.ident, word1_choice: word1.choice, word1_len: word1.end - word1.start + 1, word1_ref: word1.ref, word2_id: word2.ident, word2_choice: word2.choice, word2_len: word2.end - word2.start + 1, word2_ref: word2.ref}, function(resp) {dj_segments = resp; ko.mapping.fromJS(dj_segments, segmentMapping, self.knock_segs); selectNextSeg(index);}, true);      
      } else {
        self.sendAjaxRequest('/' + exc_id + '/excerpt_post/', {action: 'segConcatChoice', mode: mode, exc_id: exc_id, user: word1.user, word1_id: word1.ident, word1_choice: word1.choice, word1_paren: word1.paren, word1_len: word1.end - word1.start + 1}, function(resp) {dj_segments = resp; ko.mapping.fromJS(dj_segments, segmentMapping, self.knock_segs); selectNextSeg(index);}, true);
      };
      $('#seg_concat').modal('hide');
    };
    
    self.select = function(index, seg, event){
      if (!seg.hidden()) {
        //currentTarget - element powiązany z danym (ten, który był elementem for-each), w starszych przeglądarkach to srcElement
        var elem = (event.currentTarget) ? event.currentTarget : event.srcElement; 
        var target = self.closest_ancestor_with_id(elem);
        var scroll_elem_id = "";
        //console.log(target.id);
        if (!seg.isCurrent()){
          self.knock_segs()[self.current_seg()].isCurrent(false);
          self.current_seg(index);
          seg.isCurrent(true);
          if (target.id.substr(0, 4) == 'segm'){
            if (self.show_translit()){
              scroll_elem_id = "translit" + index;
            } else {
              scroll_elem_id = "orth" + index;
            }
          } else {
            scroll_elem_id = "segm" + index;
          };
          scroll(scroll_elem_id);
        };
      };
    }

    self.closest_ancestor_with_id= function(elem) {
      while (!elem.id) {
          elem = elem.parentNode;
          if (!elem) {
              return null;
          }
      }
      return elem;
    }

    self.showSeg = function(seg, val, for_list){
      var html_out ='';
      var seg_class = [];
      var tooltip = '';
      var text = '';
      var after = '';
      var ch_id = seg.fields.choice_id();
      var par_id = seg.fields.paren_id();
      var s_type = seg.fields.seg_type();
      
      switch (val) {
        case 'orth':
          text = seg.fields.orth();
          break;
        case 'translit':
          text = seg.fields.translit();
      };
      if (s_type && !text) { //dla pustych segmentów/tagów np. 'figure'
        text = '<span class="glyphicon glyphicon-star" aria-hidden="true"></span>'
      };
      
      if (ch_id){ //dla segmentów wchodzących w skład 'choice'
        seg_class.push("text-danger");
      };
      
      if (for_list) {
        text = '<strong>' + text + '</strong>';
        if (s_type) {
          after = ' &lt;' + s_type + '&gt;';
        };
      } else {
        if (seg.fields.sent_end()){ //dla segmentów kończących zdanie
          //seg_class.push("bg-primary");
          after = '&#x21B5;<p></p>'
        } else {
          after = '<span class="text-primary">|</span>';
        };
      };

      if (seg.isCurrent()){ //wyróżnij bieżący segment
        //text = '<kbd>' + text + '</kbd>';
        text = '<span class="current-seg">' + text + '</span>';
      };
      
      if (s_type) { //dodaj dymek dla segmentów z ustawionym 'type'
        tooltip = ' title="' + s_type + '" data-toggle="tooltip" data-placement="top"';
      };
      
      if (!seg.fields.base() && seg.interps()[0]) { //wyróżnij segmenty z nieustaloną interpretacją
        seg_class.push("bg-warning");
      } else { //wyróżnij segmenty z interpretacją superanotatora
        if (!seg.fields.user()) {
          seg_class.push("bg-referee");
        };
      };

      if (seg.fields.is_conflict()) { //wyróżnij segmenty z konfliktem
        if (seg.fields.user()) {
          if (!annot_id || (seg.fields.user() == annot_id)){
            seg_class.push("bg-conflict");
          } else {
            seg_class.push("bg-other");
          };
        };
      };
     
      text += after;
      
      if ((!for_list) && (seg.fields.is_hidden())) {
        if (seg.fields.is_conflict()) {
          seg_class = ' class="text-muted bg-conflict"';
        } else {
          seg_class = ' class="text-muted"';
        };
        text = '<del>' + text + '</del>';
      } else {
        if (seg_class.length != 0) {
        seg_class = ' class="' + seg_class.join(' ') + '"';
        };
      };
      html_out = '<span' + seg_class + tooltip + '>' + text + '</span>';
      
      //console.log(html_out);
      
      return html_out;
    };

    self.init = function() {
      var set_current = false; // czy udało się znaleźć jeszcze niezrobiony segment
      var first = -1; //pierwszy niezrobiony (nieukryty) element
      var j = 0;
      if (mode == 'referee') {
        self.lastRefId = self.knock_segs()[self.knock_segs().length -1].fields.ref_id();
      };
      
      while (j < self.knock_segs().length) {
        seg = self.knock_segs()[j];
        
        // sprawdź czy jest ukryte pierwsze lub ostatnie zdanie
        if (mode == 'referee') {
          if ((seg.fields.ref_id() == 1) && !seg.fields.user() && (seg.fields.ref_rejected() == 1)) {
            if (!self.showFirstSentCut()) {
              self.showFirstSentCut(true);
              if (seg.fields.is_hidden()) { self.firstSentCut(true); };
            };
          };
          if ((seg.fields.ref_id() == self.lastRefId) && !seg.fields.user() && (seg.fields.ref_rejected() == 1)) {
            if (!self.showLastSentCut()) { self.showLastSentCut(true) };
            if (!self.lastSentCut() && seg.fields.is_hidden()) { self.lastSentCut(true); };
          };
        } else {
          if (j == 0 && seg.fields.is_hidden()) {
            self.firstSentCut(true);
          };
          if (j == (self.knock_segs().length -1) && seg.fields.is_hidden()) {
            self.lastSentCut(true);
          };        
        };
                
        //Ukryj interpretacje dla oznaczonych segmentów.
        if (seg.fields.base()) {
          seg.interpsView(false);
        };
        
        // Na 'first' ustaw pierwszy nieukryty segment
//        if (first < 0 && !seg.fields.is_hidden()) {
        if (first < 0 && !seg.hidden() && (seg.fields.ref_rejected() >= 0)) {
          first = j;
        };
        
        //Jesli nie ma jeszcze ustawionego zaznaczonego segmentu, a bieżący nie jest ukryty,
        //nie ma ustawionej interpretacji i ma w ogóle jakieś interpretacje, to ustaw
        //segment bieżący jako zaznaczony
//        if (!set_current && !seg.fields.is_hidden() && !seg.fields.base() && seg.interps()[0]) {
        if (!set_current && !seg.hidden() && (seg.fields.ref_rejected() >= 0) && !seg.fields.base() && seg.interps()[0]) {
          set_current = true;
          self.current_seg(j);
          seg.isCurrent(true);
        };
        
        j++;
      };

      //Jeśli nie udało się ustalić zaznaczonego segmentu...
      if (!set_current) {
        //jeśli są segmenty odkryte, ale wszystkie mają już ustalone interpretacje
        //to jako zaznaczony segment ustaw pierwszy odkryty.
        if (first >= 0) {
          self.current_seg(first);
          self.knock_segs()[first].isCurrent(true);
        //jeśli nie ma żadnego odkrytego segmentu, to jako zaznaczony ustaw segment 0
        } else {
          self.current_seg(0);
          self.knock_segs()[0].isCurrent(true);
        };
      };
    };

    ko.mapping.fromJS(dj_segments, segmentMapping, self.knock_segs);

    self.init();
}

ko.applyBindings(new annotation_viewModel());

