# -*- coding: utf-8 -*-	
import io, sys, json

f_name = 'tagset.json'
#_replace = 'm.f.n.p1.p2.manim1.manim2.mnanim'
SORT_ORDER = ['sg', 'du', 'pl', 'nom', 'gen', 'dat', 'acc', 'inst', 'loc', 'voc', 'manim1', 'manim2', 'mnanim', 'm', 'f', 'n', 'p1', 'p2', 'pri', 'sec', 'ter', 'imperf', 'perf', 'biasp', 'aff', 'neg', 'pos', 'com', 'sup', 'akc', 'nakc', 'zneut', 'praep', 'npraep', 'wok', 'nwok', 'agl', 'nagl', 'pun', 'npun', 'comp']


if len(sys.argv) == 3:
  tagset_name = sys.argv[1]
  json_name = sys.argv[2]
elif len(sys.argv) == 2:
  tagset_name = sys.argv[1]
  json_name = 'tagset.json'
else:
  tagset_name = 'korbeusz-sxvii.tagset'
  json_name = 'tagset.json'

try:
  f_tagset = io.open(tagset_name, 'r', encoding='utf-8')
except:
  print(u'Nie mogę otworzyć pliku z tagsetem: {}'.format(tagset_name))
  sys.exit(1)
  
try:
  f_json = io.open(json_name, 'w', encoding='utf-8')
except:
  print(u'Nie mogę otworzyć pliku wyjściowego: {}'.format(json_name))
  
res_dict = {}

for line in f_tagset:
  if len(line) > 0 and (line[0] in '0123456789'):
    #line = line.replace('_', _replace)
    s_list = line.split()
    if len(s_list) > 1:
      s = s_list[1].split(':', 1)
      ctag = s[0]
      if len(s) > 1:
        msd = s[1]
      else:
        msd = ''
      msd_list = []
        
      for msd_elem in msd.split(':'):
        if '.' in msd_elem:
          or_list = [or_elem for or_elem in msd_elem.split('.')]
        else:
          or_list = [msd_elem]
        
        if len(msd_list) > 0:
          temp_list = []
          for elem in msd_list:
            for or_elem in or_list:
              temp_list.append(elem + ':' + or_elem)
          msd_list = temp_list
        else:
          msd_list.extend(or_list)  

      if res_dict.has_key(ctag):
        res_dict[ctag].extend(msd_list)
      else:
        res_dict[ctag] = msd_list

# Dołóż do tagsetu specjalne znaczniki tylko na potrzeby Anotatorni
res_dict['xxx'] = ['']
res_dict['ignndm'] = ['']

# Zlikwidowanie dubletów przez zamianę na 'set' oraz posortowanie interpretacji.
# Przy sortowaniu każdy element oddzielony dwukropkiem zamieniany jest na dwucyfrową reprezentację 
# swojego indeksu na liście SORT_ORDER (jeśli interpretacja jest pusta to sortowana jest jako '00')
for key in res_dict:
  res_dict[key] = sorted(list(set(res_dict[key])), key=lambda val : ":".join(map(lambda e : e.replace(e, '{:02d}'.format(SORT_ORDER.index(e)+1)), val.split(":"))) if len(val) > 0 else "00" )

f_json.write(unicode(json.dumps(res_dict)))
    
f_tagset.close()
f_json.close()    

def tagset_out(f_name):
  f_json = io.open(f_name, 'r', encoding='utf-8')
  f_out = io.open('tagset_out.txt', 'w', encoding='utf-8')
  json_data = json.load(f_json)
  for key in json_data:
    for msd in json_data[key]:
      f_out.write(u'{}\t{}\n'.format(key, msd))
  f_json.close()
  f_out.close()
